import { Badge } from "antd";
import moment from "moment";
import React from "react";

// 排行默认时间
export const getPresetsRanking = () => {
    let date: { [x: string]: any[] } = {
        '今天排行': [moment(), moment()],
        '昨天排行': [moment().subtract(1, 'd'), moment().subtract(1, 'd')],
        '7日排行': [moment().subtract(7, 'd'), moment()],
        '30日排行': [moment().subtract(30, 'd'), moment()]
    }
    date['当月排行'] = [moment().startOf('month'), moment()]
    return date
}

// 获取默认设置时间
export const getPresets = () => {
    let date: { [x: string]: any[] } = {
        '今天': [moment(), moment()],
        '昨天': [moment().subtract(1, 'd'), moment().subtract(1, 'd')],
        '7日': [moment().subtract(7, 'd'), moment()],
        '30日': [moment().subtract(30, 'd'), moment()]
    }
    date['当月'] = [moment().startOf('month'), moment()]
    return date
}

// 推广媒体
export enum TYPE {
    'MP' = '腾讯MP',
    'GDT' = '腾讯GDT',
    'BYTE' = '头条'
}

/**
 * 游戏类型
 */
export const gameClassifyEnum = {
    '1': 'APP',
    '2': '抖音小游戏',
    '3': 'Android App',
    '4': 'Ios App',
    '5': 'H5游戏',
    '6': '微信小游戏'
}

/**
 * 支付状态
 */
export const PayStatus = {
    '0': <Badge status="default" text="预下单" />,
    '1': <Badge status="processing" text="待支付" />,
    '2': <Badge status="success" text="支付成功" />,
    '3': <Badge status="error" text="已取消" />,
}

/**
 * 支付方式
 */
export const PayType = {
    '1': '支付宝',
    '2': '微信',
    '3': '米大师',
    'alipay': '支付宝',
    'wxpay': '微信支付',
    'mpay': '米大师'
}

/**
 * 客户端类型
 */
export const DeviceType = {
    '1': 'Android APP',
    '2': 'Ios APP',
    '3': 'H5网页',
    '4': '小程序'
}

export const LoginType = {
    '0': '注册',
    '1': '登录',
    '2': '退出'
}

// 留存数据的枚举
export enum ActiveEnum {
    reg = '注册留存',
    role = '角色留存',
    amount = '付费留存'
}

// 展示数据种类
export enum TableEnum {
    buy = '买量',
    nature = '自然量',
    total = '总量'
}

export enum SourceSystemEnum {
    BG_OLD = '布谷-old',
    BG_NEW = '布谷-new',
    ZX_SDK = '布谷-zx',
    ZX_ONE = '赞象'
}

/**
 * 支付场景
 */
export const PayScene = {
    '1': 'PC支付',
    '2': 'H5支付',
    '3': 'App支付',
    '4': '小程序支付',
    '5': '米大师支付'
}